unit main;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, ExtCtrls, ActnList, StrUtils, Math, synaser;
type
  { TForm1 }
  TForm1 = class(TForm)
    EditCom: TEdit;
    StaticText_COM: TStaticText;
    EditPolzahl: TEdit;
    StaticText_Polzahl: TStaticText;
    procedure ComEnter(Sender: TObject);
    procedure EditKeyPressInt(Sender: TObject; var Key: char);
    procedure EditKeyPressFlt(Sender: TObject; var Key: char);
    procedure X1Enter(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;


implementation

type
  TDatensatz = record
    Titel: string[255];
    uL1, uL2, uL3, iL1, iL2, iL3, fuLiL, NacheilungiL, MaschTemp, KabelTemp: double;
    StrichzahlDG, Polzahl, MaschinenTyp, Drehzahl, ZahlPT100Ma, ZahlPt100Ka: integer;
    Cosinus, CheckBoxuL23eq1, CheckBoxiL23eq1: boolean;
    ComNr: integer;
  end;

  TDfeld = class
    Datenfeld: array[1..10] of TDatensatz;
    procedure SetDatFeldStd(Nr: integer);   //Setzt Datenfeld[Nr] auf Standardwerte
  end;

  string2 = string[2];
  string4 = string[4];
  string8 = string[8];

  Erg = (Ok, Timeout, Fehler);

const
  HexTab: array[0..15] of char = ('0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F');

var
  ser: TBlockSerial;
  DFeld: TDfeld;
  NrAktDatensatz: integer;
  AktDat: TDatensatz;
  DatenVeraendert: boolean;
  Tbak, Dbak: char;

{$R *.frm}

{ TForm1 }

//// Functions/Procedures //////////////////////////////////////////////

function LimNumInputI(const EingZeile: TEdit; const LimU, LimO: integer): integer;
{Funktion setzt String in EingZeile in Integerzahl um. Danach wird Wert in Bereich LimU..LimO gezwungen.}
var
  num: integer;
begin
  try
    num := StrToInt(EingZeile.Text);  //String nach Integerzahl
    if not InRange(num, LimU, LimO) then begin  //in LimU..LimO zwingen
      num := EnsureRange(num, LimU, LimO);
      EingZeile.Text := IntToStr(num);   //Eingabe korrigieren
    end
    else
    DatenVeraendert := True;  //merken, dass neue Daten eingegeben wurden
    Result := num;  //Rückgabewert
  except
    on EConvertError do
      ShowMessage('Fehler: keine Zahl eingegeben');
  end;
end;

function LimNumInputF(const EingZeile: TEdit; const LimU, LimO: double): double;
{Funktion setzt String in EingZeile in Gleitkommazahl um, wobei , und . als Dezimalzeichen
erlaubt ist. Danach wird Wert in Bereich LimU..LimO gezwungen.}
var
  num: double;
begin
  try
    num := StrToFloat(AnsiReplaceText(EingZeile.Text, '.', ','));  //String nach Floatzahl und ggf. Dezimalpunkt durch Komma esetzen
    if not InRange(num, LimU, LimO) then begin  //in LimU..LimO zwingen
      num := EnsureRange(num, LimU, LimO);
      EingZeile.Text := IntToStr(round(num));   //Eingabe korrigieren
    end
    else
    DatenVeraendert := True;  //merken, dass neue Daten eingegeben wurden
    Result := num;  //Rückgabewert
  except
    on EConvertError do
      ShowMessage('Fehler: keine Zahl eingegeben');
  end;
end;



procedure TDfeld.SetDatFeldStd(Nr: integer);
begin
  with Datenfeld[Nr] do begin
    Titel := 'Standard';
    uL1 := 10;
    uL2 := 10;
    uL3 := 10;
    iL1 := 10;
    iL2 := 10;
    iL3 := 10;
    fuLiL := 50;
    NacheilungiL := 0;
    MaschTemp := 20;
    KabelTemp := 20;
    Drehzahl := 3000;
    StrichzahlDG := 1000;
    Polzahl := 2;
    ZahlPT100Ma := 1;
    ZahlPT100Ka := 1;
    CheckBoxuL23eq1 := True;
    CheckBoxiL23eq1 := True;
    Cosinus := True;
    ComNr := 1;
  end;
end;


procedure TForm1.EditKeyPressFlt(Sender: TObject; var Key: char);
begin
  if not (Key in ['0'..'9', ',', '.', #8]) then
    Key := #0;
end;

procedure TForm1.EditKeyPressInt(Sender: TObject; var Key: char);
begin
  if not (Key in ['0'..'9', #8]) then
    Key := #0;
end;


procedure TForm1.ComEnter(Sender: TObject);
begin
  AktDat.ComNr := StrToInt(EditCom.Text);
end;


procedure TForm1.X1Enter(Sender: TObject);
begin
  AktDat.Polzahl := 2*(LimNumInputI(EditPolzahl, 2, 12) div 2);
  if AktDat.MaschinenTyp<>1 then begin
    AktDat.fuLiL := round(AktDat.Drehzahl/60*(AktDat.Polzahl/2));
  end;
end;


initialization
  DFeld := TDFeld.Create;
  NrAktDatensatz := 1;

finalization
  DFeld.Free;
  ser.Free;

end.
